#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>

static int __init printk_kernel_module_init(void)
{
  printk(KERN_EMERG "Hello Worldl!: KERN_EMERG\n");
  printk(KERN_ALERT "Hello Worldl!: KERN_ALERT\n");
  printk(KERN_CRIT "Hello Worldl!: KERN_CRIT\n");
  printk(KERN_ERR "Hello Worldl!: KERN_ERR\n");
  printk(KERN_WARNING "Hello Worldl!: KERN_WARNING\n");
  printk(KERN_NOTICE "Hello Worldl!: KERN_NOTICE\n");
  printk(KERN_INFO "Hello Worldl!: KERN_INFO\n");
  printk(KERN_DEBUG "Hello Worldl!: KERN_DEBUG\n");
  return 0;
}

static void __exit printk_kernel_module_exit(void)
{
  printk(KERN_EMERG "Goodbye Worldl!: KERN_EMERG\n");
  printk(KERN_ALERT "Goodbye Worldl!: KERN_ALERT\n");
  printk(KERN_CRIT "Goodbye Worldl!: KERN_CRIT\n");
  printk(KERN_ERR "Goodbye Worldl!: KERN_ERR\n");
  printk(KERN_WARNING "Goodbye Worldl!: KERN_WARNING\n");
  printk(KERN_NOTICE "Goodbye Worldl!: KERN_NOTICE\n");
  printk(KERN_INFO "Goodbye Worldl!: KERN_INFO\n");
  printk(KERN_DEBUG "Goodbye Worldl!: KERN_DEBUG\n");
}

module_init(printk_kernel_module_init);
module_exit(printk_kernel_module_exit);

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Hiroyuki Chishiro");
MODULE_DESCRIPTION("Printk Kernel Module");
